#include "IDataCollector.h"
#include "ICIS.h"
#include <nsCOMPtr.h>
#include <nsCOMArray.h>

class CachedDataToCanvasRequest;

class DataCollector
  : public IDataCollector,
    public cellml_servicesIIntegrationProgressObserver
{
public:
  DataCollector();
  ~DataCollector();

  NS_DECL_ISUPPORTS;
  NS_DECL_IDATACOLLECTOR;
  NS_DECL_CELLML_SERVICESIINTEGRATIONPROGRESSOBSERVER;

private:
  PRUint32 mStatus;
  PRUint32 mnConstants, mnVariables;
  double* mNotifiedMinimums, * mNotifiedMaximums, * mTrueMinimums,
        * mTrueMaximums;
  PRUint32 mDataCapacity, mDataSize;
  double* mData;
  nsCOMArray<IDataCollectorObserver> mObservers;
  nsCOMArray<CachedDataToCanvasRequest> mDTCRs;
  PRFloat64 mBoundStart;

  bool NotifyVariableChanged(PRUint32 var);
};
